// From lecture - demonstrates animation
public class BouncingBallDeluxe {
    // renders a bouncing ball
    public static void main(String[] args) {
        // must have |rx| + radius < 1 and |ry| + radius < 1
        double rx = 0.0, ry = 0.0;        // position
        double vx = 0.015, vy = 0.023;    // velocity
        double radius = 0.1;              // radius of image

        // initialize standard drawing
        StdDraw.setXscale(-1.0, +1.0);
        StdDraw.setYscale(-1.0, +1.0);
        StdDraw.enableDoubleBuffering();

        // clear the screen
        StdDraw.clear(StdDraw.BOOK_LIGHT_BLUE);

        // main animation loop
        while (true) {
            // update position - velocity is constant
            rx = rx + vx;
            ry = ry + vy;

            // bounce off wall according to law of elastic collision
            if (Math.abs(rx) + radius > 1.0) {
                vx = -vx;
                StdAudio.playInBackground("BallTap.wav");
            }

            if (Math.abs(ry) + radius > 1.0) {
                vy = -vy;
                StdAudio.playInBackground("BlockHit.wav");
            }

            // set the background to light blue
            StdDraw.clear(StdDraw.BOOK_LIGHT_BLUE);

            // draw ball
            StdDraw.picture(rx, ry, "beach-ball.png", 2 * radius, 2 * radius);

            // display and pause for 20ms
            StdDraw.show(); // double buffer is enabled
            StdDraw.pause(20);
        }
    }
}
